<?php
/**
 * This file contains examples for using the MailWizzApi PHP-SDK.
 *
 * @author Serban George Cristian <cristian.serban@mailwizz.com>
 * @link https://www.mailwizz.com/
 * @copyright 2013-2020 https://www.mailwizz.com/
 */
 
// require the setup which has registered the autoloader
require_once 'vendor/twisted1919/mailwizz-php-sdk/examples/setup.php';
echo dirname(__FILE__) . '/template-example.html';
// create the lists endpoint:
function SendEmailToCampaign()
{
	$endpoint = new MailWizzApi_Endpoint_Campaigns();
	$response = $endpoint->create(array(
		'name'          => 'My First Test Campaign', // required
		'type'          => 'regular', // optional: regular or autoresponder
		'from_name'     => 'AHC PPE Exchange', // required
		'from_email'    => 'inventory@ppe.siseusa.org', // required
		'subject'       => 'Preview Another PPE Request', // required
		'reply_to'      => 'support@ahcusa.org', // required
		'send_at'       => date('Y-m-d H:i:s'), // required, this will use the timezone which customer selected
		'list_uid'      => 'xe0893eksn6f7', // required
		//'segment_uid'   => 'SEGMENT-UNIQUE-ID',// optional, only to narrow down
	
		// optional block, defaults are shown
		'options' => array(
			'url_tracking'      => 'no', // yes | no
			'json_feed'         => 'no', // yes | no
			'xml_feed'          => 'no', // yes | no
			'plain_text_email'  => 'yes',// yes | no
			'email_stats'       => null, // a valid email address where we should send the stats after campaign done
	
			// - if autoresponder uncomment bellow:
			//'autoresponder_event'            => 'AFTER-SUBSCRIBE', // AFTER-SUBSCRIBE or AFTER-CAMPAIGN-OPEN
			//'autoresponder_time_unit'        => 'hour', // minute, hour, day, week, month, year
			//'autoresponder_time_value'       => 1, // 1 hour after event
			//'autoresponder_open_campaign_id' => 1, // INT id of campaign, only if event is AFTER-CAMPAIGN-OPEN,
	
			// - if this campaign is advanced recurring, you can set a cron job style frequency.
			// - please note that this applies only for regular campaigns.
			'cronjob'         => '* * * * *', // once a day
			'cronjob_enabled' => 1, // 1 or 0
		),
	
		// required block, archive or template_uid or content => required.
		// the templates examples can be found here: Examples
		'template' => array(
			//'archive'         => file_get_contents(dirname(__FILE__) . '/template-example.zip'),
			//'template_uid'    => 'TEMPLATE-UNIQUE-ID',
			'content'           => 'Pravesh [COMPANY_FULL_ADDRESS], [UNSUBSCRIBE_URL]',
			'inline_css'        => 'no', // yes | no
			'plain_text'        => null, // leave empty to auto generate
			'auto_plain_text'   => 'yes', // yes | no
		),
	));
	// DISPLAY RESPONSE
	print_r($response->body);
}

SendEmailToCampaign();