<?php
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Headers: X-Requested-With');
header('Access-Control-Allow-Methods: POST, GET, OPTIONS');

require_once('inc/config.php');
require_once('inc/pdoconfig.php');
require_once('inc/pdoFunctions.php');
require_once('vendor/autoload.php');
require_once('inc/smsFunction.php');

/*Create Member using Zapier Start*/
if(isset($_POST['submit_from']) and $_POST['submit_from'] == 'Zapier')
{
		$request_token  = $_POST['request_token'];
		$vender_level   = $_POST['vender_level'];
		$first_name 	= $_POST['first_name'];
		$last_name  	= $_POST['last_name'];
		$company_name	= $_POST['company_name'];
		$email			= $_POST['email'];
		$phone			= $_POST['phone'];
		$address		= $_POST['address'];
		$city	    	= $_POST['city'];
		$state			= $prop->getName('id','state_list','Abbreviation = "'.$_POST['state'].'"');
		$zip			= $_POST['zip'];
		$tags			= rtrim($_POST['tags'],',');
		$all_tags 		= explode(',',$tags);
		$passRand 		= randomPassword();
		$cPass 			= md5($passRand);
		$input 			= array(
			'fname'		=>$first_name,
			'lname'		=>$last_name,
			'cName'		=>$company_name,
			'email'		=>$email,
			'phone'		=>$phone,
			'password'	=>$cPass,
			'address'	=>$address,
			'city'		=>$city,
			'state'		=>$state,
			'zip'		=>$zip,
			'tags'		=>json_encode( $all_tags ),
			'type'		=>3,
			'Vlevel'	=>$vender_level,
			'status'	=>0
		);
		$exist = $prop->getName('count(id)',USERS,'email = "'.$email.'"');
		if(!$exist)
		{
			$userID = $prop->addID(USERS, $input);
			
			if ($userID != 0) {
				/*Add on wallet_transaction_history*/
				$stripe_customer_token = 'ZAP_CLICKFUNNEL';
				$created_at = date('Y-m-d h:i:s');
				$updated_at = date('Y-m-d h:i:s');
				$charge_id = 'Using Zapier and ClickFunnel';
				$status = 1;
				$type = 3;
				$total_amt = 10.00;
				$net_amt = 10.00;
				$current_wallet = 10.00; //Chnage This to Price
				$credit_wallet = 10.00;//Chnage This to Price
				$avail_wallet = 10.00;//Chnage This to Price
				$reason = 'Create account using Zapier and clickfunnel';
				
				$wallet_transaction_history	= array(
					'token'				=>$stripe_customer_token,
					'user_provider_id'	=>$userID,
					'type'				=>3,
					'tokenid'			=>$stripe_customer_token,
					'payment_detail' 	=>1,
					'charge_id'			=>$charge_id,
					'paid_status'		=>1,
					'total_amt'			=>10.00,//Chnage This to Price
					'net_amt'			=>10.00,//Chnage This to Price
					'current_wallet'	=>10.00,//Chnage This to Price
					'credit_wallet'		=>10.00,//Chnage This to Price
					'avail_wallet'		=>10.00,//Chnage This to Price
					'request_token'		=>$request_token, //Chnage This to Token Amount 
					'reason'			=>$reason,
					'created_at'		=>$created_at,
					'update_on'			=>$updated_at
				);
				$result = $prop->add('wallet_transaction_history', $wallet_transaction_history);
				/*Add on wallet_transaction_history End*/
				
				/*Add on wallet_table End*/
				$wallet_table	= array(
					'token'				=>$stripe_customer_token,
					'user_provider_id'	=>$userID,
					'type'				=>3,
					'wallet_amt'		=>10,//Chnage This to Price
					'tot_request_token' =>$request_token, //Chnage This to Token Amount 
					'reason'			=>$reason,
					'created_at'		=>$created_at,
					'updated_on'		=>$updated_at
				);
				$result = $prop->add('wallet_table', $wallet_table);
				/*Add on wallet_table End*/
				
				/*Add on request_token_history End*/
				$request_token_history	= array(
					'credit_token'		=>$request_token,//Chnage This to Token Amount 
					'user_id'			=>$userID,
					'where_from'		=>$reason,
					'created'			=>$created_at				
				);
				$result = $prop->add('request_token_history', $request_token_history);
				/*Add on wallet_table End*/
			
				/*Send Email Alert start*/
				$Email_Template = $prop->get('*','Email_Template', array('status'=>0));
				$subject		=	$Email_Template['buyer_register_subject'];
				$FromName		=	$Email_Template['buyerRegisterFromName'];
				$FromEmail		=	$Email_Template['buyerRegisterFromEmail'];
				$Emailbody		=	base64_decode( $Email_Template['buyer_register_body'] );
		
				$to				=	$email;
				$logo_url 		= 'https://ppe.siseusa.org/img/ahclogo.png';
				$token = array(
					'LOGO_URL'  => $logo_url,
					'LOGIN_EMAIL'  => $email,
					'LOGIN_PASSWORD' => $passRand	
				);
				$pattern = '[%s]';
				foreach($token as $key=>$val){
					$varMap[sprintf($pattern,$key)] = $val;
				}
				
				$body = strtr($Emailbody,$varMap);
				
				$send_email = new \SendGrid\Mail\Mail();
				$send_email->setFrom($FromEmail, $FromName);
				$send_email->setSubject($subject);
				$send_email->addTo($to, $first_name." ".$last_name);
				$send_email->addContent(
					"text/html", $body
				);
				$keyval = $Email_Template['apiKey_buyer_register'];
				$sendgrid = new \SendGrid($keyval);
				try {
					$response = $sendgrid->send($send_email);
				} catch (Exception $e) {
					$errMsg =  'Caught exception: '. $e->getMessage() ."\n";
				}
				/*Send Email Alert End*/
				/*Call Zapier webhook*/
				$url = 'https://hooks.zapier.com/hooks/catch/2282216/ozgc5qo/';
				foreach($input as $key=>$value) { $fields_string .= $key.'='.$value.'&'; }
				rtrim($fields_string, '&');
				
				$ch = curl_init();
				curl_setopt($ch,CURLOPT_URL, $url);
				curl_setopt($ch,CURLOPT_POST, count($fields));
				curl_setopt($ch,CURLOPT_POSTFIELDS, $fields_string);
				$result = curl_exec($ch);
				curl_close($ch);
				/*Call Zapier webhook END*/
				
				/*Send SMS*/ //for new line %0a
				$Ccode = '1';
				//$Ccode = '91';
				$smsbody = "AHC PPE  Account Details: \n" . "Password: " . $passRand;
				$sid = sendSms(trim($phone), $smsbody, $Ccode);
				/*Send SMS END*/
			}
		}
}
/*Create Member using Zapier END*/


$myfile = fopen("newfile.txt", "w") or die("Unable to open file!");
$request_body = file_get_contents('php://input');
if($request_body == '')
{
	echo 'No access';
	exit;
}
$data = json_decode($request_body,true);
$id = $data['purchase']['id'];
$userID = '';
foreach($data['purchase']['products'] as $product)
{
	/*Create a account of PPE Buyer*/
	$details = $data['purchase'];
	if($product['id'] == 2978916)
	{
		$first_name 	= $details['contact']['first_name'];
		$last_name  	= $details['contact']['last_name'];
		$company_name	= $details['contact']['additional_info']['company_name'];
		$email			= $details['contact']['email'];
		$phone			= $details['contact']['phone'];
		$address		= $details['contact']['address'];
		$city	    	= $details['contact']['city'];
		$state			= $prop->getName('id','state_list','Abbreviation = "'.$details['contact']['state'].'"');
		$zip			= $details['contact']['zip'];
		$passRand 		= randomPassword();
		$cPass 			= md5($passRand);
		$input 			= array(
			'fname'		=>$first_name,
			'lname'		=>$last_name,
			'cName'		=>$company_name,
			'email'		=>$email,
			'phone'		=>$phone,
			'password'	=>$cPass,
			'address'	=>$address,
			'city'		=>$city,
			'state'		=>$state,
			'zip'		=>$zip,
			'type'		=>3,
			'status'	=>0
		);
		$userID = $prop->addID(USERS, $input);
		if ($userID != 0) {
			/*Add on wallet_transaction_history*/
			$stripe_customer_token = $details['stripe_customer_token'];
			$created_at = date('Y-m-d h:i:s', strtotime($details['created_at']));
			$updated_at = date('Y-m-d h:i:s', strtotime($details['updated_at']));
			$charge_id = $details['charge_id'];
			$status = 1;
			$type = 3;
			$total_amt = 10.00;
			$net_amt = 10.00;
			$current_wallet = 10.00; //Chnage This to Price
			$credit_wallet = 10.00;//Chnage This to Price
			$avail_wallet = 10.00;//Chnage This to Price
			$request_token = 2; //Chnage This to Token Amount 
			$reason = 'Create account using clickfunnel';
			
			$wallet_transaction_history	= array(
				'token'				=>$stripe_customer_token,
				'user_provider_id'	=>$userID,
				'type'				=>3,
				'tokenid'			=>$stripe_customer_token,
				'payment_detail' 	=>1,
				'charge_id'			=>$charge_id,
				'paid_status'		=>1,
				'total_amt'			=>10.00,//Chnage This to Price
				'net_amt'			=>10.00,//Chnage This to Price
				'current_wallet'	=>10.00,//Chnage This to Price
				'credit_wallet'		=>10.00,//Chnage This to Price
				'avail_wallet'		=>10.00,//Chnage This to Price
				'request_token'		=>2, //Chnage This to Token Amount 
				'reason'			=>$reason,
				'created_at'		=>$created_at,
				'update_on'			=>$updated_at
			);
			$result = $prop->add('wallet_transaction_history', $wallet_transaction_history);
			/*Add on wallet_transaction_history End*/
			
			/*Add on wallet_table End*/
			$wallet_table	= array(
				'token'				=>$stripe_customer_token,
				'user_provider_id'	=>$userID,
				'type'				=>3,
				'wallet_amt'		=>10,//Chnage This to Price
				'tot_request_token' =>2, //Chnage This to Token Amount 
				'reason'			=>$reason,
				'created_at'		=>$created_at,
				'updated_on'		=>$updated_at
			);
			$result = $prop->add('wallet_table', $wallet_table);
			/*Add on wallet_table End*/
			
			/*Add on request_token_history End*/
			$request_token_history	= array(
				'credit_token'		=>2,//Chnage This to Token Amount 
				'user_id'			=>$userID,
				'where_from'		=>$reason,
				'created'			=>$created_at				
			);
			$result = $prop->add('request_token_history', $request_token_history);
			/*Add on wallet_table End*/
		
			/*Send Email Alert start*/
			$Email_Template = $prop->get('*','Email_Template', array('status'=>0));
			$subject		=	$Email_Template['buyer_register_subject'];
			$FromName		=	$Email_Template['buyerRegisterFromName'];
			$FromEmail		=	$Email_Template['buyerRegisterFromEmail'];
			$Emailbody		=	base64_decode( $Email_Template['buyer_register_body'] );
	
			$to				=	$email;
			$logo_url 		= 'https://ppe.siseusa.org/img/ahclogo.png';
			$token = array(
				'LOGO_URL'  => $logo_url,
				'LOGIN_EMAIL'  => $email,
				'LOGIN_PASSWORD' => $passRand	
			);
			$pattern = '[%s]';
			foreach($token as $key=>$val){
				$varMap[sprintf($pattern,$key)] = $val;
			}
			
			$body = strtr($Emailbody,$varMap);
			
			$send_email = new \SendGrid\Mail\Mail();
			$send_email->setFrom($FromEmail, $FromName);
			$send_email->setSubject($subject);
			$send_email->addTo($to, $first_name." ".$last_name);
			$send_email->addContent(
				"text/html", $body
			);
			$keyval = $Email_Template['apiKey_buyer_register'];
			$sendgrid = new \SendGrid($keyval);
			try {
				$response = $sendgrid->send($send_email);
			} catch (Exception $e) {
				$errMsg =  'Caught exception: '. $e->getMessage() ."\n";
			}
			/*Send Email Alert End*/
			
			/*Call Zapier webhook*/
			$url = 'https://hooks.zapier.com/hooks/catch/2282216/ozgc5qo/';
			foreach($input as $key=>$value) { $fields_string .= $key.'='.$value.'&'; }
			rtrim($fields_string, '&');
			
			$ch = curl_init();
			curl_setopt($ch,CURLOPT_URL, $url);
			curl_setopt($ch,CURLOPT_POST, count($fields));
			curl_setopt($ch,CURLOPT_POSTFIELDS, $fields_string);
			$result = curl_exec($ch);
			curl_close($ch);
			/*Call Zapier webhook END*/
			
			/*Send SMS*/ //for new line %0a
			//$Ccode = '1';
			$Ccode = '91';
			$smsbody = "AHC PPE  Account Details: \n" . "Password: " . $passRand;
			$sid = sendSms(trim($phone), $smsbody, $Ccode);
			/*Send SMS END*/
			
		}
	} /*Create a account of PPE Buyer END*/
	else if($product['id'] == 2978971) /*Add Extra 5 Token*/
	{
		$email			= $details['contact']['email'];
		$user_details = $prop->get('*',USERS, array('email'=>$email));
		if($user_details['id'] != '')
		{
			
			$userID = $user_details['id'];
			/*Add on wallet_transaction_history*/
			$walletdata = $prop->get('*','wallet_table', array('user_provider_id'=>$userID));
			
			$stripe_customer_token = $details['stripe_customer_token'];
			if($stripe_customer_token == '')
			$stripe_customer_token = $walletdata['token'];
			
			$created_at = date('Y-m-d h:i:s', strtotime($details['created_at']));
			$updated_at = date('Y-m-d h:i:s', strtotime($details['updated_at']));
			$charge_id = $details['charge_id'];
			$reason = 'Wallet Top Up - 5 Token from CF';
			
			$wallet_transaction_history	= array(
				'token'				=>$stripe_customer_token,
				'user_provider_id'	=>$userID,
				'type'				=>3,
				'tokenid'			=>$stripe_customer_token,
				'payment_detail' 	=>1,
				'charge_id'			=>$charge_id,
				'paid_status'		=>1,
				'total_amt'			=>250.00,
				'net_amt'			=>250.00,
				'current_wallet'	=>250.00,
				'credit_wallet'		=>250.00,
				'avail_wallet'		=>250.00,
				'request_token'		=>5,
				'reason'			=>$reason,
				'created_at'		=>$created_at,
				'update_on'			=>$updated_at
			);
			$result = $prop->add('wallet_transaction_history', $wallet_transaction_history);
			/*Add on wallet_transaction_history End*/
			/*Add on wallet_table End*/
			$tot_request = $walletdata['tot_request_token'] + 5;
			$wallet_amt = $walletdata['wallet_amt'] + 250;
			$wallet_table	= array(
				'wallet_amt'		=>$wallet_amt,
				'tot_request_token' =>$tot_request,
				'updated_on'		=>$updated_at
			);
			$result = $prop->update('wallet_table', $wallet_table, array("user_provider_id" =>$userID));
			/*Add on wallet_table End*/
			/*Add on request_token_history End*/
			$request_token_history	= array(
				'credit_token'		=>5,
				'user_id'			=>$userID,
				'where_from'		=>$reason,
				'created'			=>$created_at				
			);
			$result = $prop->add('request_token_history', $request_token_history);
			
		}
	}/*Add Extra 5 Token End*/
	else if($product['id'] == 2978974) /*Add Extra 12 Token*/
	{
		$email			= $details['contact']['email'];
		$user_details = $prop->get('*',USERS, array('email'=>$email));
		if($user_details['id'] != '')
		{
			
			$userID = $user_details['id'];
			/*Add on wallet_transaction_history*/
			$walletdata = $prop->get('*','wallet_table', array('user_provider_id'=>$userID));
			
			$stripe_customer_token = $details['stripe_customer_token'];
			if($stripe_customer_token == '')
			$stripe_customer_token = $walletdata['token'];
			
			$created_at = date('Y-m-d h:i:s', strtotime($details['created_at']));
			$updated_at = date('Y-m-d h:i:s', strtotime($details['updated_at']));
			$charge_id = $details['charge_id'];
			
			
			$request_token = 12;
			$reason = 'Wallet Top Up - 12 Token from CF';
			
			$wallet_transaction_history	= array(
				'token'				=>$stripe_customer_token,
				'user_provider_id'	=>$userID,
				'type'				=>3,
				'tokenid'			=>$stripe_customer_token,
				'payment_detail' 	=>1,
				'charge_id'			=>$charge_id,
				'paid_status'		=>1,
				'total_amt'			=>500.00,
				'net_amt'			=>500.00,
				'current_wallet'	=>500.00,
				'credit_wallet'		=>500.00,
				'avail_wallet'		=>500.00,
				'request_token'		=>12,
				'reason'			=>$reason,
				'created_at'		=>$created_at,
				'update_on'			=>$updated_at
			);
			$result = $prop->add('wallet_transaction_history', $wallet_transaction_history);
			/*Add on wallet_transaction_history End*/
			/*Add on wallet_table End*/
			$tot_request = $walletdata['tot_request_token'] + 12;
			$wallet_amt = $walletdata['wallet_amt'] + 500;
			$wallet_table	= array(
				'wallet_amt'		=>$wallet_amt,
				'tot_request_token' =>$tot_request,
				'updated_on'		=>$updated_at
			);
			$result = $prop->update('wallet_table', $wallet_table, array("user_provider_id" =>$userID));
			/*Add on wallet_table End*/
			
			/*Add on request_token_history End*/
			$request_token_history	= array(
				'credit_token'		=>12,
				'user_id'			=>$userID,
				'where_from'		=>$reason,
				'created'			=>$created_at				
			);
			$result = $prop->add('request_token_history', $request_token_history);
			
		}
	}/*Add Extra 5 Token End*/
	
	
	
	$txt = 'first_name:- '.$first_name.'last_name:- '.$last_name.'company_name:- '.$company_name.'email:- '.$email.'phone:- '.$phone.'address:- '.$address.'city:- '.$city.'state:- '.$state.'zip:- '.$zip;
	fwrite($myfile, $txt);
}
fclose($myfile);

function randomPassword() {
    $alphabet = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890';
    $pass = array(); //remember to declare $pass as an array
    $alphaLength = strlen($alphabet) - 1; //put the length -1 in cache
    for ($i = 0; $i < 8; $i++) {
        $n = rand(0, $alphaLength);
        $pass[] = $alphabet[$n];
    }
    return implode($pass); //turn the array into a string
}
?>