<?Php 
require_once('inc/config.php');
require_once('inc/pdoconfig.php');
require_once('inc/pdoFunctions.php');
require_once('vendor/autoload.php');
require_once('inc/PhpScripts.php');
error_reporting(E_ALL);
ini_set('display_errors',true);


global $cdb,$db,$prop;
$cdb = new DB();
$db = $cdb->getDb();
$prop = new PDOFUNCTION($db);

$StripeData = $prop->get('*','admin_setting', array('option_name'=>'stripe_details'));

$StData = array();
if(!empty($StripeData))
    $StData = json_decode($StripeData['option_value'],true);

$apikey = $StData['secret'];
if(empty($StData) || $apikey=="") {
    @header("location: user-wallet.php?message='no api key'");
    exit();
}

define('STRIPE_API',$apikey);

@session_start();

function get_customer_id() {
    global $cdb,$db,$prop;
    $customerid = "";
    $customrerdata = $prop->get('*','stripe_customer_table', array('user_id'=>$_SESSION['U']['id']));
    if(!empty($customrerdata)) {
        
        $customerid = $customrerdata['cust_id'];
    }
    
    return $customerid;    
}


function create_customer($stripeToken,$stripeEmail,$amountInCents,$Userdata) {
    global $cdb,$db,$prop;
    $adresslione1 = $postalcode = $state = $country = $name = "";
    if(!empty($Userdata)) {
        $adresslione1 = urlencode($Userdata['address']);
        $city = urlencode($Userdata['city']);
        $state = urlencode($Userdata['state']);
        
        $statedetail = $prop->get('*','state_list', array('id'=>$state));
        $state = $statedetail['State'];
        $zip = urlencode($Userdata['zip']);
        $name = urlencode($Userdata['fname'].' '.$Userdata['lname']);
    }
    
    $ch = curl_init();

    curl_setopt($ch, CURLOPT_URL, 'https://api.stripe.com/v1/customers');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, "email=$stripeEmail&source=$stripeToken&name=$name&address[line1]=$adresslione1&address[postal_code]=$zip&address[city]=$city&address[state]=$state&address[country]=US");
    curl_setopt($ch, CURLOPT_USERPWD, STRIPE_API . ':' . '');
    
    $headers = array();
    $headers[] = 'Content-Type: application/x-www-form-urlencoded';
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    
    $result = curl_exec($ch);
    if (curl_errno($ch)) {
        echo 'Error:' . curl_error($ch);
    }
    curl_close($ch);
    $res = json_decode($result);
    return $res;
}


if(!isset($_POST['stripeToken']))
 return "Invalid Payment";
 
$stripeToken = $_POST['stripeToken'];
$stripeEmail = $_POST['stripeEmail'];
$amountInCents = $_POST['amountInCents']; 
$requestToken = $_POST['requestToken']; 
$customerdata = array();
if(get_customer_id()=="") {
    
    $Userdata = $prop->get('*','appuser', array('id'=>$_SESSION['U']['id'],'status'=>0));
    
    $customerdata = create_customer($stripeToken,$stripeEmail,$amountInCents,$Userdata);
    $customerid = $customerdata->id;

} else {
     $customerid = get_customer_id();
}



// payment process
$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, 'https://api.stripe.com/v1/charges');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, "customer=$customerid&description=Wallet Money&amount=$amountInCents&currency=USD");
curl_setopt($ch, CURLOPT_USERPWD, STRIPE_API . ':' . '');

$headers = array();
$headers[] = 'Content-Type: application/x-www-form-urlencoded';
curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

$result = curl_exec($ch);
if (curl_errno($ch)) {
    echo 'Error:' . curl_error($ch);
}
curl_close($ch);
$payresponse = json_decode($result);

if(!isset($payresponse->status)) {
     @header("location: user-wallet.php?message=payment Failed. Money not deducted!");
    exit();
}

if(!empty($payresponse) && $payresponse->status=="succeeded") {
    
    $tokenval = $stripeToken;
    
    $userid   = $_SESSION['U']['id'];
    $usertype = $_SESSION['U']['user_type'];
    $useremail = $_SESSION['U']['email'];
    
    $amount = $amountInCents / 100;
    
    $created = date("Y-m-d H:i:s",$payresponse->created);
    $chargeid = $payresponse->id;
    $txnid = $payresponse->balance_transaction;
    $cardid = $payresponse->payment_method;-
    $paid = $payresponse->paid;
    $cardtype = $payresponse->payment_method_details->card->brand;
    $currency = $payresponse->currency;
    $cvccheck = $payresponse->payment_method_details->card->checks->cvc_check;
    $cardnumber = $payresponse->payment_method_details->card->last4;
    $cardexpmonth = $payresponse->payment_method_details->card->exp_month;
    $cardexpyear = $payresponse->payment_method_details->card->exp_year;
    
    
    $total_amt = $amount;
    
    $walletdata = $prop->get('*','wallet_table', array('user_provider_id'=> $userid));
    $walletamount = 0;
    $currentwalletamount = 0;
    if(!empty($walletdata)){
        
        $currentwalletamount = $walletdata['wallet_amt'];
		$current_tot_request_token = $walletdata['tot_request_token'];
        $walletamount = $currentwalletamount + $total_amt;
		$tot_request_token = $current_tot_request_token + $requestToken;
        
        $input  = array(
				'token'				=>$tokenval,
				'wallet_amt'		=>$walletamount,
				'tot_request_token'	=>$tot_request_token,
				'updated_on'		=>$created
			); 
        
        $prop->update('wallet_table', $input, array("user_provider_id" =>$userid));
        
    } else {
        
        $walletamount = $amount;
        $input  = array(
				'token'				=>$tokenval,
				'user_provider_id'	=>$userid,
				'type'				=>$usertype,
				'wallet_amt'		=>$amount,
				'tot_request_token'	=>$requestToken,
				'created_at'		=>$created,
				'updated_on'		=>$created
			);  
        $walletId = $prop->addID('wallet_table', $input);    
    }
    
     $input  = array(
				'token'				=>$tokenval,
				'user_provider_id'	=>$userid,
				'type'				=>$usertype,
				'tokenid'			=>$tokenval,
				'payment_detail'	=>1,
				'charge_id'			=>$chargeid,
				'transaction_id'	=>$txnid,
				'exchange_rate'		=>0,
				'paid_status'		=>$paid,
				'total_amt'			=>$total_amt,
				'fee_amt'			=>0,
				'net_amt'			=>$total_amt,
				'amount_refund'		=>0,
				'current_wallet'	=>$currentwalletamount,
				'credit_wallet'		=>$total_amt,
				'debit_wallet'		=>0,
				'avail_wallet'		=>$walletamount,
				'request_token'		=>$requestToken,
				'reason'			=>'Wallet Top Up - '.$requestToken.' Token',
				'created_at'		=>$created,
				'update_on'			=>$created
			);  
    $walletId = $prop->addID('wallet_transaction_history', $input);
	
	/*Add On Token History */
	$input_token  = array(
				'user_id'			=>$userid,
				'credit_token'		=>$requestToken,
				'debit_token'		=>0,
				'where_from'		=>'Wallet Top Up - '.$requestToken.' Token from PPE App',
				'created'			=>$created,
			);  
    $requestedID = $prop->addID('request_token_history', $input_token);
	
	
    
    
    
    $stripecustData = $prop->get('*','stripe_customer_table', array('user_id'=> $userid));
    if(empty($stripecustData)) {
        
       $input  = array(
				'user_token'	=>$tokenval,
				'cust_id'		=>$customerid,
				'email'			=>$useremail,
				'user_id'		=>$userid,
				'currency'		=>$currency,
				'created_at'	=>$created,
				'updated_on'	=>$created
			);  
        $stripecustdetail = $prop->addID('stripe_customer_table', $input); 
    } else {
        
         $input  = array(
				'user_token'	=>$tokenval,
				'currency'		=>$currency,
				'updated_on'	=>$created
			); 
        
        $prop->update('stripe_customer_table', $input, array("user_id" =>$userid));
        
    }
    
    $input  = array(
				'user_token'		=>$tokenval,
				'stripe_token'		=>$tokenval,
				'pay_type'			=>'card',
				'brand'				=>$cardtype,
				'cvc_check'			=>$created,
				'cust_id'			=>$customerid,
				'card_id'			=>$cardid,
				'card_number'		=>$cardnumber,
				'card_exp_month'	=>$cardexpmonth,
				'card_exp_year'		=>$cardexpyear,
				'status'			=>0,
				'created_at'		=>$created,
				'updated_on'		=>$created
			);  
    $stripecustdetail = $prop->addID('stripe_customer_card_details', $input);
    
    if($walletId)
        @header("location: user-wallet.php");
    exit();
}

?>